using System;
using System.Linq;
using NUnit.Framework;

namespace Encompass
{
    namespace Tests {
        class MockComponent : Component {
            public string myString;
            public int myInt;
        }

        public class EntityTest
        {
            [Test]
            public void AddComponent()
            {
                var world = new World();
                var entity = world.CreateEntity();

                var mockComponent = entity.AddComponent<MockComponent>();
                mockComponent.myString = "hello";
                mockComponent.myInt = 3;

                world.Update();

                Assert.IsTrue(entity.HasComponent<MockComponent>());
                Assert.AreEqual(3, entity.GetComponent<MockComponent>().myInt);
                Assert.AreEqual("hello", entity.GetComponent<MockComponent>().myString);
            }
        }
    }
}
